# ==================================================================
# Links SQL - enhanced directory management system
#
#	Website  : http://ultranerds.com/
#	Support  : http://ultranerds.com/forum
#
# Parts Copyright (c) 2000 Gossamer Threads Inc.  All Rights Reserved.
# Modified by PUGDOG Enterprises, Inc.  Parts Copyright 2000-2005
# Modified by UltraNerds
# ==================================================================

package Plugins::SearchLogger;
# ==================================================================
	use strict;
	use vars qw/$VERSION $DEBUG $NAME $FONT/;
	use GT::Plugins qw/STOP CONTINUE/;
	use Links qw/$IN $DB $CFG/;

	$VERSION	= '3.0.0';
	$DEBUG		= 0;
	$NAME       = 'SearchLogger';
	$FONT		= 'font face="Tahoma,Arial,Helvetica" size="2"';

sub view {
# -------------------------------------------------------------------
# This is the admin view, it lets people search on keywords
# and purge old listings.
#
	my $db			= $DB->table('SearchLog');
	my $days = $IN->param('days');
	if (defined $days and $days =~ /^\d+$/) {
		Links::init_date();
		my $date = GT::Date::date_get (time - 86400 * $days);
		if ($IN->param('total')) {
			$db->delete ( GT::SQL::Condition->new ( 'Last_Hit', '<', $date) );
		}
	}
	my $nh   = $IN->param('nh') || 1;
	my $mh   = $IN->param('mh') || 25;
	my $sth  = $db->query_sth ($IN);
	my $hits = $sth->rows;
	my $tb   = $DB->html($db,$IN)->toolbar ($nh, $mh, $hits, $IN->url);

	my $output  = qq~
<table border=1 cellpadding=0 cellspacing=0><tr><td>
	<table border=0 width=500>
	<tr><td><$FONT><a href='admin.cgi?do=plugin&plugin=$NAME&func=view&Term=*&sb=Term&so=ASC&nh=$nh'>Term</a></font></td>
	    <td><$FONT><a href='admin.cgi?do=plugin&plugin=$NAME&func=view&Term=*&sb=HitCount&so=DESC&nh=$nh'>Count</a></font></td>
	    <td><$FONT><a href='admin.cgi?do=plugin&plugin=$NAME&func=view&Term=*&sb=Results&so=DESC&nh=$nh'>Results</a></font></td>
	    <td><$FONT><a href='admin.cgi?do=plugin&plugin=$NAME&func=view&Term=*&sb=Last_Hit&so=DESC&nh=$nh'>Last Searched</a></font></td>
	</tr>
	~;			
	while (my $hit = $sth->fetchrow_hashref) {
		my $escaped = $IN->escape ($hit->{Term});
		$output .= qq!
			 <tr><td><$FONT><a href="$CFG->{db_cgi_url}/search.cgi?query=$escaped" target="_linksearch">$hit->{Term}</a></font></td><td><$FONT>$hit->{HitCount}</font></td><td><$FONT>$hit->{Results}</font></td><td><$FONT>$hit->{Last_Hit}</font></td></tr>
		!;		
	}
	$output .= "</table></td></tr></table>";
	print $IN->header();

	print qq~
<html>
<head>
    <title>Links SQL: Keyword Searches.</title>
</head>

<body bgcolor="#FFFFFF">
    <form action="admin.cgi" method="GET">
    <input type=hidden name="do" value="plugin">
	<input type=hidden name="func" value="view">
	<input type=hidden name="plugin" value="$NAME">
	<input type=hidden name="Term" value="*">
	~;
	print Links::header ('Keyword Searches', 'This screen shows you a list of keywords people have searched for', 0);
	print qq~
    <p><$FONT>$output</font></p>
	~;
	($tb) and print "<p><$FONT>Pages: $tb</font></p>";	
	print qq~
<table border=1 cellpadding=0 cellspacing=0><tr><td><table border=0 width=500><tr><td>
    <p><$FONT>Purge listings older then <input name=days size=4> days old. 
	<BR>
		<input name=total type=checkbox selected> Purge Totals table <BR>
		<input type=submit value="Purge">
	</font></p>
</td></tr></table>
</form>
</body>
</html>
	~;
}
sub view_daily {
# -------------------------------------------------------------------
# This is the admin view, it lets people search on keywords
# and purge old listings.
#
	my $db_daily	= $DB->table('SearchLogDaily');
	my $days = $IN->param('days');
	if (defined $days and $days =~ /^\d+$/) {
		Links::init_date();
		my $date = GT::Date::date_get (time - 86400 * $days);
		if ($IN->param('daily')) {
			$db_daily->delete ( GT::SQL::Condition->new ( 'Last_Hit', '<', $date) );
		}
	}
	my $nh   = $IN->param('nh') || 1;
	my $mh   = $IN->param('mh') || 25;
	my $sth  = $db_daily->query_sth ($IN);
	my $hits = $sth->rows;
	my $tb   = $DB->html($db_daily,$IN)->toolbar ($nh, $mh, $hits, $IN->url);

	my $output  = qq~
<table border=1 cellpadding=0 cellspacing=0><tr><td>
	<table border=0 width=500>
	<tr><td><$FONT><a href='admin.cgi?do=plugin&plugin=$NAME&func=view_daily&Term=*&sb=Term&so=ASC&nh=$nh'>Term</a></font></td>
	    <td><$FONT><a href='admin.cgi?do=plugin&plugin=$NAME&func=view_daily&Term=*&sb=HitCount&so=DESC&nh=$nh'>Count</a></font></td>
	    <td><$FONT><a href='admin.cgi?do=plugin&plugin=$NAME&func=view_daily&Term=*&sb=Results&so=DESC&nh=$nh'>Results</a></font></td>
	    <td><$FONT><a href='admin.cgi?do=plugin&plugin=$NAME&func=view_daily&Term=*&sb=Last_Hit&so=DESC&nh=$nh'>Last Searched</a></font></td>
	    <td><$FONT><a href='admin.cgi?do=plugin&plugin=$NAME&func=view_daily&Term=*&sb=Hit_Date&so=DESC&nh=$nh'>Hit Date</a></font></td>
	</tr>
	~;			
	while (my $hit = $sth->fetchrow_hashref) {
		my $escaped = $IN->escape ($hit->{Term});
		$output .= qq!
			 <tr>
				<td><$FONT><a href="$CFG->{db_cgi_url}/search.cgi?query=$escaped" target="_linksearch">$hit->{Term}</a></font></td>
				<td><$FONT>$hit->{HitCount}</font></td>
				<td><$FONT>$hit->{Results}</font></td>
				<td><$FONT>$hit->{Last_Hit}</font></td>
				<td><$FONT>$hit->{Hit_Date}</font></td>
			</tr>
		!;		
	}
	$output .= "</table></td></tr></table>";
	print $IN->header();

	print qq~
<html>
<head>
    <title>Links SQL: Keyword Searches.</title>
</head>

<body bgcolor="#FFFFFF">
    <form action="admin.cgi" method="GET">
    <input type=hidden name="do" value="plugin">
	<input type=hidden name="func" value="view">
	<input type=hidden name="plugin" value="$NAME">
	<input type=hidden name="Term" value="*">
	~;
	print Links::header ('Keyword Searches', 'This screen shows you a list of keywords people have searched for', 0);
	print qq~
    <p><$FONT>$output</font></p>
	~;
	($tb) and print "<p><$FONT>Pages: $tb</font></p>";	
	print qq~
<table border=1 cellpadding=0 cellspacing=0><tr><td><table border=0 width=500><tr><td>
    <p><$FONT>Purge listings older then <input name=days size=4> days old. 
	<BR>
		<input name=daily type=checkbox selected> Purge Daily table <BR>
		<input type=submit value="Purge">
	</font></p>
</td></tr></table>
</form>
</body>
</html>
	~;
}

sub log_query {
# -------------------------------------------------------------------
# This is the search hook, it happens after the search and the only
# argument it gets is $opts which is what would get sent to the search
# template. Hooks default to continue processing, if you wanted to not
# run the main search, you should call GT::Plugins->action ( STOP );
#
	my $opts	= shift;
	my $db		= $DB->table ('SearchLog');
	my $db_daily	= $DB->table ('SearchLogDaily');
	my $query	= $IN->param('query');
	my $results = defined $opts->{link_hits} ? int($opts->{link_hits}) : 0;

	$query =~ s/^\s*|\s*$//g;
	$query = lc $query;
	$query = substr ($query, 0, 24);

	if ($query eq '*') { 								## added 04/26/05
            print $IN->header();
            print Links::SiteHTML::display('search', { error => 'Invalid Query'});
            return;
	}

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	if ($year >= 100) {$year = $year+1900};			## correct for year 2000
	$mon++;											## months are 0 based -- distance from begining of year 
	if ($mon  < 10) {$mon  = "0$mon"};
#$mday = $mday+1;
	if ($mday < 10) {$mday = "0$mday"};
	my $current_Tday = "$year-$mon-$mday";

## update regular log table
	$db->select ( {Term => $query} );
	if ($db->hits) {
		$db->update (
			{
				HitCount => \"HitCount+1",
				Results  => $results,
				Last_Hit => $current_Tday
			},
			{
				Term => $query
			}
			);
	}
	else {
		$db->insert ( { 
				Term => $query, 
				HitCount => 1, 
				Results => $results, 
				Last_Hit => $current_Tday
				});
		$db->update (
			{
				Last_Hit => $current_Tday
			},
			{
				Term => $query
			}
			);
	}

## update daily table
	$db_daily->select ( {Term => $query, Hit_Date => $current_Tday} );
	if ($db_daily->hits) {
		$db_daily->update ( 
							{ 
								HitCount => \"HitCount+1",
								Results  => $results								
							},
							{
								Term => $query,
								Hit_Date => $current_Tday
							}
							);
	}
	else {
		$db_daily->insert ( { Term => $query, HitCount => 1, Results => $results, Last_Hit => $current_Tday, Hit_Date => $current_Tday});
	}
	
	
	return $opts;
}


sub Top_Keywords {
# ----------------------------------------------- 
# Returns a list of the Top5 Searched terms. 
#
my ($num, $type) = @_;
my ($s_table, $s_order, $search_db, $sth, $output);				## define them all here to make it easier to read the code
if ($type eq 'd') {
	$s_table = 'SearchLogDaily';
	$s_order = 'HitCount';
} elsif ($type eq 'r') {
	$s_table = 'SearchLog';
	$s_order = 'TS';
} else {
	$s_table = 'SearchLog';
	$s_order = 'HitCount';
}

## added 04/26/05 to fix up a display problem for sites with few searches.
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	if ($year >= 100) {$year = $year+1900};			## correct for year 2000
	$mon++;											## months are 0 based -- distance from begining of year 
	if ($mon  < 10) {$mon  = "0$mon"};
#$mday = $mday+1;
	if ($mday < 10) {$mday = "0$mday"};
	my $current_Tday = "$year-$mon-$mday";


$search_db = $DB->table($s_table);					## connect to the table, grab a handle
$search_db->select_options ("ORDER BY $s_order DESC", "LIMIT $num");	## set the options for the select
if ($s_table eq 'SearchLogDaily') {  #Limit searches to today
		$sth = $search_db->select ( {Hit_Date => $current_Tday} ) ;								## execute the select, assign to a statement handle
	} else {
		$sth = $search_db->select;								## execute the select, assign to a statement handle
	}
if ($search_db->hits) {
	my $db_cgi_url	= $CFG->{'db_cgi_url'};
	#$output = '<Table border=1 cellpadding=5><TR><TD><%body_font%>Term</font></td><td><%body_font%>Hits</font></td></tr>'; 
	$output = '<ul>';
	while (my $row = $sth->fetchrow_hashref) {
		my $term		= $row->{'Term'};
		my $term_q		= $IN->escape($row->{'Term'});	## $IN is a CGI object
	#	$output .= qq~ <TR><TD><font size=2><a href="$db_cgi_url/search.cgi?query=$term_q">$term</a></font></td><td align=center><font size=2>$row->{'Results'}</font></td></tr> ~;
	$output	 .= qq~ <li><font face=2><a href="$db_cgi_url/search.cgi?query=$term_q">$term</a></font> ~;
	}
	#$output .= '</table></UL>';
	$output .= '</url>';
} else {
	$output = "Sorry no one has Searched for anything yet.";
}
return $output; 
} 


sub about {
# -------------------------------------------------------------------
# Displays a help screen.
#
    print $IN->header;
    print <<'END_OF_HELP';
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<title>Plugins::SearchLogger</title>
</head>

<body>
<basefont face="Tahoma">
<table cellSpacing="0" cellPadding="0" border="1">
  <tbody>
    <tr>
      <td>
        <table cellSpacing="3" cellPadding="3" width="500" bgColor="#ffffff" border="0" valign="top">
          <tbody>
            <tr>
              <td align="left" bgColor="navy"><b><font face="Tahoma,Arial,Helvetica" color="#ffffff" size="2">Plugin:
                SearchLogger</font></b></td>
            </tr>
            <tr>
              <td>
                <p align="center"><b><font face="Tahoma,Arial,Helvetica" color="#000000" size="2">SearchLogger</font></b></p>
                <p><font face="Tahoma,Arial,Helvetica" size="2">This improved/updated SearchLogger
                plugin is a simple addition to your search engine. It will log
                all queries that visitors perform, and allow you to browse them
                from the admin.  It was one of the first plugins I wrote, and it was a hacked/modified  "replacement"
				version of Alex's original SearchLogger.  
				</P>
				<P><B>NOTE!!!!!</B> Also, this was written for Links 2.x, and is not GLinks template compatible
					as much of the HTML is generated in the code.  This will be changed, once GLinks 3.0.x is stabilized.
				</P>
			</font>
                <p><font face="Tahoma,Arial,Helvetica" size="2">When you
                installed this plugin it created two new tables called SearchLog and SearchLogDaily
                which store all queries and extra info such as time of last search. 
				On your left should now be a new menu
                item called View Logs. Clicking on this will allow you to view
                what people have searched on. There is also an option to remove
                old search terms. Simply enter the number of days and hit enter.</font></p>
				<P><B>NOTE!!</B>The view and delete options are a little flakey, but will be improved
				for use with Glinks 3.0.1x shortly.  It should be a drop-in replacement that will
				use the old tables, but just add some new features.  
				</P>

<B>
                <p><font face="Tahoma,Arial,Helvetica" size="2">If you have
                questions about this plugin, please visit the support forum at:</font></p>
                <blockquote>
                  <p><font face="Tahoma,Arial,Helvetica" size="2"><a href="http://ultranerds.com/forum/">http://UltraNerds.com/forum/</a></font></p>
                </blockquote>
</b>

<basefont face="Tahoma" size=2>
<P>
From the original announcement:
<UL>
<LI>More compatible with Links' interrnal standard table structure 
<LI>2.1 logic compatible 
<LI>Tracks both daily and total searches 
<LI>Can return daily totals 
<LI>Can return totals 
<LI>Can return the most recent hits 
<LI>Uses a function call <%Plugins::SearchLogger::Top_Keywords ('nn', 't|r|d')%> where 'nn' is the number of terms to return, and t,r,d stands for totals, recent, or daily hits where you can specify the # of terms to return. 
<LI>Delete old records from the admin by a date-older-than format. 
<LI>Copyrighted Freeware, no charge to use, but must credit the original sources ie: Gossamer-Threads & Pugdog Enterprises, Inc.
</ul>
</P>
<P>
Once installed, it functions just as the original SearchLogger, but it maintains two tables. 
SearchLog and SearchLogDaily. The SearchLog table should still work with any globals you may 
have running off it. No guarantee, but it should -- as long as you are not using the ->get construct to call the records. 
</p>
<p><B>GLinks 3.0 Note:</B> You *should* be able to run this and the built-in search logger together, without any problems.
</P>
<P>
You use the plugin by inserting the function call into your template where you want the list of terms to reside. 
</P>
<P>
&lt;%Plugins::SearchLogger::Top_Keywords ('10')%&gt; 
</P>
<P>
Would return the 10 most search key words (same as if you used ('10', 't'). 
</P>
<P>
&lt;%Plugins::SearchLogger::Top_Keywords ('10', 'd')%&gt; 
</P>
<P>
Would return the top 10 keywords for the current day, starting at midnight (not a 24 hour span, a calendar day) 
</P>
<P>
&lt;%Plugins::SearchLogger::Top_Keywords ('11', 'r')%&gt; 
</P>
<P>
Would return the most recent 11 searches, even if they spanned several days. 
</P>
<P>
If there are fewer than the requested number of records for the daily search, it returns only what it finds. 
</P>

              </td>
            </tr>
          </tbody>
        </table>
      </td>
    </tr>
  </tbody>
</table>

</body>

</html>
END_OF_HELP
}

1;
